/*
Autor: Luis Bravo
Fecha: 16-05-2022
 */
package Vista;

import Controlador.MPI;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * @author bravotoledo
 */
public class Ventana extends javax.swing.JFrame {

    /**
     * Creates new form Ventana
     */
     MPI mpi;
    public Ventana() {
        initComponents();
        mpi = new MPI();
        confIniciales();
        
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        Titulo = new javax.swing.JLabel();
        areaText = new javax.swing.JTextArea();
        seleccionarFile = new javax.swing.JButton();
        outRuta = new javax.swing.JTextField();
        nProcesadores = new javax.swing.JLabel();
        Ejecutar = new javax.swing.JButton();
        salirBtn = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        intNPText = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        Titulo.setFont(new java.awt.Font("Chandas", 1, 24)); // NOI18N
        Titulo.setForeground(new java.awt.Color(250, 243, 243));
        Titulo.setText("TRABAJO FINAL UNIDAD 1");
        jPanel1.add(Titulo, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 20, -1, 44));

        areaText.setColumns(20);
        areaText.setFont(new java.awt.Font("Chandas", 0, 10)); // NOI18N
        areaText.setRows(5);
        jPanel1.add(areaText, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 180, 610, 300));

        seleccionarFile.setText("SELECCIONAR");
        seleccionarFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                seleccionarFileActionPerformed(evt);
            }
        });
        jPanel1.add(seleccionarFile, new org.netbeans.lib.awtextra.AbsoluteConstraints(495, 62, -1, -1));

        outRuta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                outRutaActionPerformed(evt);
            }
        });
        jPanel1.add(outRuta, new org.netbeans.lib.awtextra.AbsoluteConstraints(90, 64, 399, -1));

        nProcesadores.setFont(new java.awt.Font("Chandas", 1, 13)); // NOI18N
        nProcesadores.setForeground(new java.awt.Color(254, 242, 242));
        nProcesadores.setText("# Procesadores Disponebles: ");
        jPanel1.add(nProcesadores, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 110, 240, 27));

        Ejecutar.setFont(new java.awt.Font("Chandas", 1, 13)); // NOI18N
        Ejecutar.setText("Ejecutar");
        Ejecutar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EjecutarActionPerformed(evt);
            }
        });
        jPanel1.add(Ejecutar, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 140, 105, 36));

        salirBtn.setFont(new java.awt.Font("Chandas", 1, 13)); // NOI18N
        salirBtn.setText("Salir");
        salirBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                salirBtnActionPerformed(evt);
            }
        });
        jPanel1.add(salirBtn, new org.netbeans.lib.awtextra.AbsoluteConstraints(430, 140, 105, 36));

        jLabel1.setFont(new java.awt.Font("Chandas", 1, 13)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(253, 243, 243));
        jLabel1.setText("Numero de procesadores:");
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 110, -1, 30));

        intNPText.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                intNPTextActionPerformed(evt);
            }
        });
        jPanel1.add(intNPText, new org.netbeans.lib.awtextra.AbsoluteConstraints(510, 110, 70, -1));

        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Imagenes/2560x1600-px-PC-Master-Race-Steam-software-1273763-wallhere.com.jpg"))); // NOI18N
        jPanel1.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(-800, -70, 1550, 660));

        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 670, 490));

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void EjecutarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EjecutarActionPerformed
        // TODO add your handling code here:
        if(mpi.esNUmero(intNPText.getText())==true){
            if (mpi.getRuta()!=null) {
                if (mpi.validarExtencion()==true) {
                    if (Integer.parseInt(intNPText.getText())<=mpi.getNprocesadores() && 
                        Integer.parseInt(intNPText.getText())>0) {
                        mpi.ejecutar(Integer.parseInt(intNPText.getText()),areaText);
                    } else {
                        JOptionPane.showMessageDialog(null,
                        "Numero de procesadores incorrecto, porfavor vuelva a ingresarlo",
                        "Advertencia",
                        JOptionPane.WARNING_MESSAGE);
                    }
                }else{
                    JOptionPane.showMessageDialog(null,
                    "Seleccione el archivo con extención .c",
                    "Advertencia",
                    JOptionPane.WARNING_MESSAGE);
                }
            } else {
                JOptionPane.showMessageDialog(null,
                    "Seleccione el archivo",
                    "Advertencia",
                    JOptionPane.WARNING_MESSAGE);
            }
        }else{
                JOptionPane.showMessageDialog(null,
                    "Porfavor,Ingrese el numero de procesadores",
                    "Advertencia",
                    JOptionPane.WARNING_MESSAGE);
        }
        
    }//GEN-LAST:event_EjecutarActionPerformed

    private void outRutaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_outRutaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_outRutaActionPerformed

    private void seleccionarFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_seleccionarFileActionPerformed
        // TODO add your handling code here:
        JFileChooser obRuta = new JFileChooser();
        obRuta.showOpenDialog(obRuta);
        try {
            String ruta = obRuta.getSelectedFile().getAbsolutePath();
            outRuta.setText(ruta);
            mpi.setRuta(ruta);
            File file = new File(ruta);
            mpi.compilarFile(file.getAbsolutePath());
        } catch (NullPointerException e) {
            JOptionPane.showMessageDialog(null,
                "No se ha seleccionado ningún fichero",
                "Advertencia",
                JOptionPane.WARNING_MESSAGE);
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }//GEN-LAST:event_seleccionarFileActionPerformed

    private void intNPTextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_intNPTextActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_intNPTextActionPerformed

    private void salirBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_salirBtnActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_salirBtnActionPerformed

    public void confIniciales(){
        mpi.numeroProcesadores();
        nProcesadores.setText(nProcesadores.getText()+" "+mpi.getNprocesadores());
        areaText.setLineWrap(true);
        areaText.setEditable(false); 
        outRuta.setEditable(false);
        
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Ventana().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Ejecutar;
    private javax.swing.JLabel Titulo;
    private javax.swing.JTextArea areaText;
    private javax.swing.JTextField intNPText;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel nProcesadores;
    private javax.swing.JTextField outRuta;
    private javax.swing.JButton salirBtn;
    private javax.swing.JButton seleccionarFile;
    // End of variables declaration//GEN-END:variables
}
